// movingavg.h
//
// Copyright (c) 2001,2002 Andrew McGill and Leading Edge Business Solutions
//
// This file is part of dialserver.
//
// dialserver is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free
// Software Foundation; either version 2 of the License, or (at your option)
// any later version.
//
// dialserver is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
// more details.
//
// You should have received a copy of the GNU General Public License along with
// dialserver; if not, write to the Free Software Foundation, Inc., 59 Temple
// Place, Suite 330, Boston, MA  02111-1307  USA
#define MOVINGAVERAGESIZE 600
typedef struct _MOVINGAVERAGE {
	int integral;
	int count;
	int pointer;
	int offset;
	int x[MOVINGAVERAGESIZE];
} MOVINGAVERAGE;

typedef enum _INTEGRAL_TYPE {
	INTEGRAL_SLOPPY=0,  /* Do or die */
	INTEGRAL_STRICT=1,  /* Return an integral of available data, even if it is less */
	INTEGRAL_ALL=2      /* Return entire count since time t=0 */
} INTEGRAL_TYPE;


void mva_start(MOVINGAVERAGE *avg, int initialvalue);
int mva_count(MOVINGAVERAGE *avg);
int mva_getdiff(MOVINGAVERAGE *avg, int a, int b);
void mva_addvalue(MOVINGAVERAGE *avg, int value);
int mva_integral(MOVINGAVERAGE *avg, int ticks, INTEGRAL_TYPE isstrict);
