<?php
// Copyright (c) 2001,2002 Andrew McGill and Leading Edge Business Solutions
//
// This file is part of dialserver.
//
// dialserver is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free
// Software Foundation; either version 2 of the License, or (at your option)
// any later version.
//
// dialserver is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
// more details.
//
// You should have received a copy of the GNU General Public License along with
// dialserver; if not, write to the Free Software Foundation, Inc., 59 Temple
// Place, Suite 330, Boston, MA  02111-1307  USA

$basepage = $PHP_SELF;

include "inc.php";

// Image
define("trafficwidth",400);
define("trafficheight",132);
define ("chost_server", "localhost");
define ("cport_no", 2200);
define ("cerror_ip", "127.0.0.1");


function showcontinue()
{
	global $basepage, $thetime;
	echo "<p>To view the status of the dial-out connection, click 
		<A HREF=\"$basepage?time=$thetime&task=status\">here</A>. 
		If you are logged in, you can log out by clicking 
		<A HREF=\"$basepage?time=$thetime&task=disconnect\">here</A>. 
		";
}


function showform()
{
	global $thetime, $basepage;
?>
<CENTER>
<TABLE WIDTH=80%>
<TR><TD VALIGN=top>
<A HREF="<?php echo "$basepage?time=$thetime&"; ?>task=connect">Connect</A>
</TD><TD>
You need to log in before you can access the internet from 
your computer.  A telephone connection will be made by the 
server if one does not currently exist.  Note that your time
on line is logged.
</TD></TR>
<TR><TD VALIGN=top>
<A HREF="<?php echo "$basepage?time=$thetime&"; ?>task=disconnect">Disconnect</A>
</TD><TD>
End your internet session.  When the last internet user logs out,
the telephone connection is disconnected.  
</TD></TR>
<TR><TD VALIGN=top>
<A HREF="<?php echo "$basepage?time=$thetime&"; ?>task=status">Status</A>
</TD><TD>
Show the current status of the internet connection.
</TD></TR>
<TR><TD VALIGN=top>
<A HREF="<?php echo "$basepage?time=$thetime&"; ?>task=log">Log</A>
</TD><TD>
Show the log.  This can be helpful in diagnosing 
problems.
</TD></TR>

<TR><TD VALIGN=top>
<A HREF="<?php echo "$basepage?time=$diagnose&"; ?>task=diagnose">Diagnose</A>
</TD><TD>
Show some technical information about what the system is doing right now.
</TD></TR>

</TABLE>
</CENTER>

<?php
}


function getRemoteIpAddress ()
{
      // 1) Check for proxy use by looking at HTTP_VIA.
      // 2) If no HTTP_VIA.
      //    a) Get the remote address.  
      //    b) Do some checks on the address.  
      //    c) Translate all addresses that appear incorrect into 
      //       127.0.0.1.
      // 3) If HTTP_VIA.
      //    a) Check for squid.
      //       i) Get HTTP_X_FORWARDED_FOR.  
      //       ii) Check the address.  
      //       iii) If no squid and an error.  
      //           *) If incorrect address is retrieved then return 
      //              REMOTE_ADDRESS.  
      //           *) Check the address and return 127.0.0.1 if an 
      //              error occurs.  
      //       iv) Set the result to 127.0.0.1 if a failure occurs.  
      //
      // !!!! Squid is blocking IP forward.
      //      Refuse to wrok with this option turned on.  
      //      Fix unknown.  
      $ip = getenv("HTTP_X_FORWARDED_FOR");
      
      if (!is_string($ip)||(strlen($ip)==0))
        $ip = getenv("REMOTE_ADDR");

      if (!is_string($ip)||(strlen($ip)==0))
	$ip = cerror_ip;
      
      return $ip;
}

// Written from scratch by Andrew!  (Cloning Murray's code, of course)
function server_querydialserver($query)
{
	global $fp;
	// Open socket
	if (!$fp) {
		$fp = fsockopen (chost_server, cport_no, 
			&$errno, &$errstr);
		if (!$fp) {
			return "Problem: $errstr (is dialserver running?)";
		}
	}
	// Send query
	fputs ($fp, "$query\n");
	// Read response and clean it up (strip \n's)
	$response="";
	while (!feof($fp)) {
		$buffer = fgets($fp, 4096);
		$buffer = str_replace("\r","",$buffer);
		if ($buffer == "\n") // End of reply is blank line
			break;
		$response = $response . $buffer;
	}
	// Return everything except the first \n
	return $response;
}


// Send a query, and return the response
function server_askandrecieve($query,$break) 
{
	$response = server_querydialserver($query);
	return str_replace("\n",$break,$response);
}

// Send a query, and format the reply
function server_askandtabulate($item, $query) 
{
	global $blue;
	$TDleft0 = "<TD bgcolor=$blue>";
	$TDleft = "<TD bgcolor=$blue align=right>";
	$break = "</TD></TR><TR>$TDleft" ;
	$response = server_askandrecieve($query,$break);
	$response = str_replace(": ","</TD><TD>",$response);
	return "<TABLE cellpadding=2 cellspacing=1 width=100%>
		<TR>$TDleft <b>$item</b></TD>$TDleft0 <b>Details</b></TD></TR>
		<TR>$TDleft $response</TD></TR>
		</TABLE>";
}

function dialserver_login()
{
/* Check for values in $PHP_AUTH_USER and $PHP_AUTH_PW */ 
	global $PHP_AUTH_USER;
	global $PHP_AUTH_PW;

	if ((isset($PHP_AUTH_USER)) && (isset($PHP_AUTH_PW))) { 
		/* Values contain some values, so check to see if they're correct */ 
		$response = server_querydialserver("LOGIN $PHP_AUTH_USER $PHP_AUTH_PW");
		if (strncmp($response,"Hello",5)==0) {
			return 1;
		}
		$response = "Dialserver response was: $response";
	}
	/* Ask a user and password send headers causing dialog box to appear */
	header('WWW-Authenticate: Basic realm="Dial server"');
	header('HTTP/1.0 401 Unauthorised');
	echo "Authorization required.  $response";
	exit; 
} 

// Pull a value out of the string
function parsevalue($tag, $response)
{
	$splat = explode("\n",$response);
	while (list ($key, $val) = each ($splat)) {
		list($thistag, $thisval) = explode(": ",$val);
		if ($thistag == $tag) { return $thisval; }
	}
	return "";
}

function showhistoryimage()
{
	// Get the history of the last 133 packets
	$response = server_querydialserver("HISTORY 100");
	list($RX,$TX,$final)=explode("\n",$response);
	$rx = explode(" ",$RX);
	$tx = explode(" ",$TX);
	$count = min(count($rx), count($tx)) - 1;
	if ($count<1) $count=1;
	$maximum = 60;

	// Parameters
	$hoffset=32;
	$voffset= 16;
	$width=trafficwidth - $hoffset;
	$height=trafficheight - $voffset - 16;
	$bar = 4;
	$unit = $height / $maximum;
	$count = min($count, $width/$bar);

	// Make it
	$im = imagecreate(trafficwidth,trafficheight);
	$white = ImageColorAllocate($im, 255,255,255);
	$grey  = ImageColorAllocate($im, 64,64,64);
	$txcol = ImageColorAllocate($im, 0,0x80,0);
	$rxcol = ImageColorAllocate($im, 0x99,0x99,255);
	$bgcol = ImageColorAllocate($im, 255,255,255);
	$black = ImageColorAllocate($im, 0,0,0);
	$bordercol = ImageColorAllocate($im, 196,196,255);

	ImageFilledRectangle($im, $hoffset, $voffset, $width+$hoffset, $voffset+$height, $bgcol);
	// Horizontal lines
	ImageRectangle($im,$hoffset,$voffset+$height/2,$hoffset+$width-1,$voffset+$height/4*3,$bordercol);
	for ($a = 0; $a < $count; $a++) {
		// RX: green, TX: push
		$left = $width - ( $a * $bar)+$hoffset;
		ImageFilledRectangle($im, 
			$left, $voffset + $height - min($height, $unit * $rx[$a+1]), 
			$left+1, $voffset + $height,
			$rxcol);
		ImageFilledRectangle($im, 
			$left+2, $voffset + $height - min($height, $unit * $tx[$a+1]+1), 
			$left+3, $voffset + $height,
			$txcol);
	}
	ImageRectangle($im,$hoffset+$width-6*$bar,$voffset,$hoffset+$width-12*$bar,$voffset+$height+1,$bordercol);
	ImageRectangle($im,$hoffset+$width-24*$bar,$voffset,$hoffset+$width-48*$bar,$voffset+$height+1,$bordercol);
	ImageString($im,3,$hoffset,1,"Packets recieved and transmitted",$grey);
	ImageString($im,3,$hoffset,1,"        recieved                ",$rxcol);
	ImageString($im,3,$hoffset,1,"                     transmitted",$txcol);
	ImageString($im,3,$hoffset,$voffset+$height+2,"old",$grey);
	ImageString($im,3,$hoffset+$width-7*3-2,$voffset+$height+2,"now",$black);
	ImageRectangle($im,$hoffset,$voffset,$hoffset+$width-1,$voffset+$height+1,$bordercol);
	ImageStringUp($im,3,1,$voffset+$height-8,"Packets /sec",$black);
	ImageStringUp($im,3,16,$voffset+$height,"0",$grey);
	$m = $maximum / 5;
	ImageStringUp($im,3,16,$voffset+16,"$m",$grey);

	ImagePng($im);
	ImageDestroy($im);
}

function nocache()
{
	header("Date: " . gmdate("D, d M Y H:i:s") . " GMT");		// always modified
	header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");             // Date in the past
	header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT"); // always modified
	header("Cache-Control: no-cache, must-revalidate");           // HTTP/1.1
	header("Pragma: no-cache");                                   // HTTP/1.0
}
  /*=================================================================*/

  $ip = getRemoteIpAddress();


  switch ($task) {
	// Log in and show results
	case "connect":
		dialserver_login();
		nocache();
		showheader(0);
		showheadline("Start connection - $ip");
		$response = server_askandrecieve("START $ip","<BR>\n");
		echo "Login response: <i>$response</i>\n";
		showcontinue();
		showfooter();
		break;

	// Log out
	case "disconnect":
		dialserver_login();
		nocache();
		showheader();
		showheadline("Internet logout - $ip");
		$response = server_askandrecieve("STOP $ip","<BR>\n");
		echo "Logout response: <i>$response</i>";
		showcontinue();
		showfooter();
		break;
// Show log
	case "log":
		nocache();
		showheader(0);
		showheadline("Connection log");
		$response = server_askandrecieve("LOG","<BR>\n");
		echo "Log of recent activity:<p>$response";
		showfooter();
		break;

	// Show diagnose
	case "diagnose":
		nocache();
		showheader(0);
		showheadline("Diagnose the connection");

		// WARNING: UGLY hacks below:
		$TDleft0 = "<TD bgcolor=$blue>";
		$TDleft = "<TD bgcolor=$blue valign=top>";
		$break = "</TD></TR><TR>$TDleft" ;
		$response = server_querydialserver("DIAGNOSE");
		$response = str_replace("\n \n","\n",$response);
		$response = htmlspecialchars($response);
		$response = str_replace(" ","&nbsp;",$response);
		$response = str_replace("[[","</TD></TR><TR>$TDleft<i>",$response);
		$response = str_replace("]]\n","</i></TD><TD>",$response);
		$response = nl2br($response);
		echo "<TABLE cellpadding=2 cellspacing=1 width=100%>
			<TR>$TDleft <b>Item</b></TD>$TDleft0 <b>Details</b>
			$response</TD></TR>
			</TABLE>";

		showfooter();
		break;

	case "switch":
		header("Location: $basepage?time=$thetime&task=monitor");
		dialserver_login();
		$response = server_querydialserver("STATUS $ip");
		$linkstatus = parsevalue("Link status",$response);
		if ($linkstatus=="") {
			server_querydialserver("START $ip");
		}
		else {
			server_querydialserver("STOP $ip");
		}
		break;

	case "monitor":
		dialserver_login();
		header("Refresh: 5; URL=$basepage?time=$thetime&task=monitor");
		echo "<HTML><HEAD><TITLE>Connection for $PHP_AUTH_USER</TITLE><BODY
alink=black vlink=black bgcolor=#DDDDDD>
<STYLE TYPE=\"text/css\">
<!--
BODY  {
	background: #DDDDDD;
	color: black ;
	padding: 0 0 0 0;
	margin: 0 0 0 0; 
	}
A {
	text-decoration: none;
	color: black;
}
TD.yes {
	border: #00FF00 2 inset;
	border-color: #00FF00;
	border-style: inset;
	border-width: 2;
	padding: 0 0 0 0;
	margin: 0 0 0 0;
	text-align: center;
	color: black ;
	background: white;
	}
TD.huh {
	border: inset 2 #808000;
	border-color: #808000;
	border-style: inset;
	border-width: 2;
	text-align: center;
	color: black ;
	padding: 0 0 0 0;
	margin: 0 0 0 0;
	text-align: center;
	background: white;
	}
TD.no {
	border: inset 2 #DDDDDD;
	border-color: #DDDDDD;
	border-style: inset;
	border-width: 2;
	text-align: center;
	color: black;
	padding: 0 0 0 0;
	margin: 0 0 0 0;
	text-align: center;
	background: #CCCCCC;
	}
-->
</STYLE>
		
		";
		$response = server_querydialserver("STATUS $ip");
		$linkstatus = parsevalue("Link status",$response);
		if ($linkstatus=="") {
			$linkstatus = "Not connected";
			$linkclass = "no";
		}
		else {
			$linkclass = "yes";
		}
		$linestatus = parsevalue("Line",$response);
		if (strpos($linestatus,"ialled in")) {
			$lineclass = "yes";
		}
		else if (strpos($linestatus,"ff line")) {
			$lineclass = "no";
		}
		else {
			$lineclass = "huh";
		}
		echo "<TABLE cellpadding=2 cellspacing=8 border=0 height=100% width=100%>
			<TR height=50%>
			<TD class=$lineclass>$linestatus</TD>
			</TR>
			<TR height=50%>
			<TD class=$linkclass>
			<A HREF=$basepage?time=$thetime&task=switch
			class=$linkclass>$linkstatus</A></TD></TR>
			</A></TD></TR>
			</TABLE>";
		echo "</BODY></HTML>";
		break;

	case "status":
		nocache();
		showheader(0);
		$currentstatus = server_askandtabulate("Item","STATUS $ip");
		$currentlyloggedon = server_askandtabulate("Who","WHO");
		showheadline("Internet connection status");
		echo "
		<p><b>Current status</b><BR>
		$currentstatus
		";
		echo "
		<p><b>Recent traffic</b><BR>
		<CENTER>
		<IMG src=\"?task=history.png\" 
		width=", trafficwidth, " height=", trafficheight, ">
		</CENTER>
		<p><b>Currently logged on</b><BR>
		$currentlyloggedon
		";
		showfooter();
		break;

	case "history.png":
		nocache();
		Header("Content-type: image/png");
		showhistoryimage();
		break;

	// Move to somewhere definite
	case "control":
	default:
		nocache();
		showheader(0);
		showheadline("Internet connection control - $ip");
		showform();
		showfooter();
		break;

  }

