// server.h
//
// Copyright (c) 2001,2002 Andrew McGill and Leading Edge Business Solutions
//
// This file is part of dialserver.
//
// dialserver is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free
// Software Foundation; either version 2 of the License, or (at your option)
// any later version.
//
// dialserver is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
// more details.
//
// You should have received a copy of the GNU General Public License along with
// dialserver; if not, write to the Free Software Foundation, Inc., 59 Temple
// Place, Suite 330, Boston, MA  02111-1307  USA
#ifndef _SERVER_H
#define _SERVER_H

#define SOCK_OUTBUFFER 8192
#define SOCK_INBUFFER 8192

// A connected socket
typedef struct _CLIENTBUFFER {
	int fd;				// Socket
	int disconnect;			// Set if we should disconnect soon
	int inb;			// Number of bytes in the input queue
	int outb;			// Number of bytes in the output queue
	char inbuffer[SOCK_INBUFFER];	// The input buffer
	char *outbuffer;		// The output buffer (malloc'd)
	char peer[64];			// Who are we talking to
	int userflags;			// public: state information about this connection
	char userdata[32];		// public: state information about this connection
} CLIENTBUFFER;

/* A server what accepts and handles multiple connections */
int srv_startserver(int port, 
	   char *unixsocket,
	   void (*callback)(CLIENTBUFFER *client, char *request),
	   int polltime);
void srv_echodebug(CLIENTBUFFER *client, char *request );
void srv_printf(CLIENTBUFFER *client, char *format, ...);
void srv_putc(CLIENTBUFFER *client, char c);
void echoresponse(CLIENTBUFFER *client, char *request);

#endif
