// shell.h
//
// Copyright (c) 2001,2002 Andrew McGill and Leading Edge Business Solutions
//
// This file is part of dialserver.
//
// dialserver is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free
// Software Foundation; either version 2 of the License, or (at your option)
// any later version.
//
// dialserver is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
// more details.
//
// You should have received a copy of the GNU General Public License along with
// dialserver; if not, write to the Free Software Foundation, Inc., 59 Temple
// Place, Suite 330, Boston, MA  02111-1307  USA

pid_t shell_exec(char *command);
char *shell_removeescapes(char *param);
pid_t shell_exec_bg(char *prompt, char *command);
pid_t shell_exec_bg_params(char *prompt, char *command, char *params);
int shell_inline(char *command, char *buffer, int *buflen);
char *shell_inline_alloc(char *command, int *exitstatus);
void shell_panic(char *message);

// These shell functions don't work :) -- or they might, but I haven't tried
// them.  You can.  Go for it.

// Information about a process we control
typedef struct _SHELLINFO {
	pid_t pid;
	int stdin, stdout;
	char *bufferin, *bufferout;
	int inb, outb;
	int exitstatus;
} SHELLINFO;

int shell_kill(SHELLINFO *shell, int signal);
void shell_close(SHELLINFO *shell);
SHELLINFO *shell_create(char *command);

// Information about a process we control
typedef struct _PIPEINFO {
	pid_t pid;
	FILE *pipe;
	char *data;
	int bufsize;
	int bufmaximum;
	int exitstatus;
} PIPEINFO;

