// util.c -- shared code of the useful sort
//
// Copyright (c) 2001,2002 Andrew McGill and Leading Edge Business Solutions
//
// This file is part of dialserver.
//
// dialserver is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free
// Software Foundation; either version 2 of the License, or (at your option)
// any later version.
//
// dialserver is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
// more details.
//
// You should have received a copy of the GNU General Public License along with
// dialserver; if not, write to the Free Software Foundation, Inc., 59 Temple
// Place, Suite 330, Boston, MA  02111-1307  USA
#include "common.h"

// strdup or die.  If you xstrdup(NULL)=NULL
char *xstrdup(char *string)
{
	char *res;
	if (!string) return NULL;
	res = strdup(string);
	if (!res) {
		perror("strdup");
		exit(18);
	}
	return res;
}

// Malloc or die
void *xmalloc(size_t size)
{
	void *res;
	res = malloc(size);
	if (!res) {
		perror("malloc");
		exit(17);
	}
	return res;
}

// Realloc or die -- if you realloc(n,0) then the result is NULL
void *xrealloc(void *ptr,size_t size)
{
	void *res;
	res = realloc(ptr,size);
	if (!res && size!=0) {
		perror("realloc");
		exit(17);
	}
	return res;
}

// calloc or die
void *xcalloc(size_t nmemb, size_t size) 
{
	void *res;
	res = calloc(nmemb,size);
	if (!res) {
		perror("calloc");
		exit(17);
	}
	return res;
}
